package org.objectweb.petals.binding.axis2bc;

import javax.jbi.JBIException;
import javax.jbi.component.Component;
import javax.jbi.component.ComponentContext;
import javax.jbi.component.ComponentLifeCycle;
import javax.jbi.component.ServiceUnitManager;
import javax.jbi.messaging.DeliveryChannel;
import javax.jbi.messaging.MessageExchange;
import javax.jbi.servicedesc.ServiceEndpoint;
import javax.management.ObjectName;
import javax.xml.namespace.QName;

import org.apache.axis2.context.ConfigurationContext;
import org.w3c.dom.Document;
import org.w3c.dom.DocumentFragment;

public class Axis2BC implements Component, ComponentLifeCycle {

	public static ComponentContext context;
	
	public static DeliveryChannel channel;
	
	public static String helloService = "Helloworld";
	
	public static String helloOperation = "printMessage";
	
	public static ConfigurationContext axisConfigurationContext;
	
	private Axis2BCListener listener;
	
	@SuppressWarnings("unused")
	private ServiceEndpoint endpointReference;
	
    private static final String SERVICE = "Axis2BC";
	
	public void init(ComponentContext context) throws JBIException
	{
		System.out.println("init()");
		System.out.println("Initialize the Axis2BC service");
		
		try {
			
			Axis2BC.context = context;
			
		} 
		catch (Exception e) 
		{
			System.out.println("init()");
			throw new JBIException(e);
		}
		
		// 
		
		
	}
	
	public void shutDown() throws JBIException {
		// TODO: implement shutdown method
	}
	
	public void start() throws JBIException {
		System.out.println("start()");
		System.out.println("Start the Helloworld service");
		
		Axis2BC.channel = Axis2BC.context.getDeliveryChannel();
		this.listener = new Axis2BCListener(Axis2BC.channel, Axis2BC.context);
		
		Thread.currentThread().setContextClassLoader(this.getClass().getClassLoader());
    	
		Thread listenerThread = new Thread(this.listener);
		listenerThread.setContextClassLoader(this.getClass().getClassLoader());
		listenerThread.start();
		endpointReference = Axis2BC.context.activateEndpoint(new QName(SERVICE), context.getComponentName()+"Endpoint");
	}
	
	public void stop() throws JBIException {
		// TODO: implement stop method
	}
	
	public ComponentLifeCycle getLifeCycle() {
		System.out.println("Component instance asked to provide a LifeCycle.");
        return this;
    }
	
	public Document getServiceDescription(ServiceEndpoint arg0) {
		// TODO Auto-generated method stub
		return null;
	}
	
	public ServiceUnitManager getServiceUnitManager() {
		System.out.println("Component instance asked to provide a ServiceUnitManager.");
		return null;
	}
	
	public boolean isExchangeWithConsumerOkay(ServiceEndpoint arg0,
			MessageExchange arg1) {
		return true;
	}
	
	public boolean isExchangeWithProviderOkay(ServiceEndpoint arg0,
			MessageExchange arg1) {
		return true;
	}
	
	public ServiceEndpoint resolveEndpointReference(DocumentFragment arg0) {
		// TODO Auto-generated method stub
		return null;
	}
	
	public ObjectName getExtensionMBeanName() {
		// TODO Auto-generated method stub
		return null;
	}

}
