package org.objectweb.petals.binding.axis2bc;

import java.io.File;

import javax.jbi.JBIException;
import javax.jbi.component.Bootstrap;
import javax.jbi.component.InstallationContext;
import javax.management.ObjectName;

/**
 * 
 * @author ofabre
 *
 */
public class Axis2BCBootstrapImpl implements Bootstrap{
	
	InstallationContext context;
	
	public void cleanUp() throws JBIException {
		System.out.println("Axis2BCBootstrapImpl cleanUp");

	}

	public ObjectName getExtensionMBeanName() {
		System.out.println("Axis2BCBootstrapImpl getExtensionMBeanName");
		return null;
	}

	public void init(InstallationContext installContext) throws JBIException {
		System.out.println("Axis2BCBootstrapImpl init");
		context = installContext;

	}

	public void onInstall() throws JBIException 
	{
		System.out.println("Axis2BCBootstrapImpl onInstall");
	
		// Axis2 needs a repository composed of a "modules" and "services" directory.
		File installPath = new File(context.getInstallRoot());
		
		File modules = new File(installPath,"modules");
		File services = new File(installPath,"services");
		
		modules.mkdirs();
		services.mkdirs();
		
		
		// copy .mar files to the modules directory
		
		File[] metaInfFiles = new File(installPath,"META-INF").listFiles();
		for (File file : metaInfFiles) 
		{
			if (file.getName().endsWith(".mar"))
			{
				file.renameTo(new File(modules,file.getName()));
			}
			if (file.getName().equals("axis2.xml"))
			{
				file.renameTo(new File(installPath,file.getName()));
			}
		}
	}

	public void onUninstall() throws JBIException 
	{
		System.out.println("Axis2BCBootstrapImpl onUninstall");
	
		File installPath = new File(context.getInstallRoot());
		
		File modules = new File(installPath,"modules");
		File services = new File(installPath,"services");
		
		modules.delete();
		services.delete();
	}

}
