package org.objectweb.petals.binding.axis2bc;

import javax.jbi.component.ComponentContext;
import javax.jbi.messaging.DeliveryChannel;
import javax.jbi.messaging.MessageExchange;
import javax.jbi.messaging.MessagingException;

import org.apache.axis2.transport.http.SimpleHTTPServer;
import org.objectweb.petals.binding.axis2bc.util.SourceHelper;

public class Axis2BCListener implements Runnable{
	
	// AXIS2 parameters
	private int DEFAULT_PORT = 8080;
	
	private SimpleHTTPServer receiver;

	private DeliveryChannel channel;
	
	private ComponentContext context;
	
	private MessageExchange messageExchange;
	
	private boolean running;
	
	
	
	public Axis2BCListener(DeliveryChannel channel, ComponentContext context) {
		super();
		this.channel = channel;
		this.context = context;
	}



	public void run() {
		
		System.out.println("[SimpleHTTPServer] Starting");
        System.out.println("[SimpleHTTPServer] Using the Axis2 Repository "
                + context.getInstallRoot());
        System.out.println("[SimpleHTTPServer] Listening on port " + DEFAULT_PORT);
        try  {
        	// Set the context classloader of the thread that running Axis2BC 
        	// to the component classloader that handles all JBI Component classpath
        	receiver = new SimpleHTTPServer(context.getInstallRoot(), DEFAULT_PORT);
            receiver.start();
            receiver.getConfigurationContext().setProperty("component-context",context);
            Axis2BC.axisConfigurationContext = receiver.getConfigurationContext();
            System.out.println("[SimpleHTTPServer] Started");
        } catch (Throwable t){
        	t.printStackTrace();
            System.out.println("[SimpleHTTPServer] Shutting down");
        }

        while(running)
		{
			try 
			{
				messageExchange = channel.accept();
				
				if(messageExchange != null)
				{
					System.out.println("AxisBC received response:"+ SourceHelper.createStringContent(messageExchange.getMessage("IN").getContent()));
				}
			}
			catch (MessagingException e) {
				e.printStackTrace();
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
        
        // TODO: adding process of a outgoing message (from JBI component to external WS)
		
	}

}
