package org.objectweb.petals.engine.clock;

import javax.jbi.JBIException;
import javax.jbi.component.Bootstrap;
import javax.jbi.component.InstallationContext;
import javax.management.ObjectName;

/**
 * 
 * @author ofabre
 *
 */
public class ClockBootstrapImpl implements Bootstrap{
	
	private InstallationContext ctx;
	
	public void cleanUp() throws JBIException {
		System.out.println("Bootstrap called to clean up allocated ressources.");
		System.out.println("Cleaning the Installation context");
		ctx = null;
	}

	public ObjectName getExtensionMBeanName() {
		System.out.println("Bootstrap called to get ExtensionMBeanName.");
		return null;
	}

	public void init(InstallationContext installContext) throws JBIException {
		System.out.println("Bootstrap instance initiated.");
		ctx = installContext;

	}

	public void onInstall() throws JBIException {
		System.out.println("Bootstrap instance installed.");
		System.out.println("Installation = "+ctx.isInstall());
		System.out.println(ctx.getClassPathElements());
	}

	public void onUninstall() throws JBIException {
		System.out.println("Bootstrap instance uninstalled.");
		System.out.println("Installation = "+ctx.isInstall());
		}
}
