package org.objectweb.petals.engine.clock;

import java.io.File;
import java.io.FileInputStream;

import javax.jbi.component.ServiceUnitManager;
import javax.jbi.management.DeploymentException;

public class ClockServiceUnitManager implements ServiceUnitManager {

	
	private Clock clock;

	public ClockServiceUnitManager(Clock clock) {
		this.clock = clock;
	}

	public String deploy(String serviceUnitName, String serviceUnitRootPath)
			throws DeploymentException {
		try {
			FileInputStream in = new FileInputStream(serviceUnitRootPath + File.separator + serviceUnitName);
			TimeZonesMap tzm = new TimeZonesMap(in);
			// TODO check for duplicate
			clock.addTimeZonesForArtifact(serviceUnitName,tzm);
		} catch (Exception e) {
			throw new DeploymentException("Problem while deploying artefact " + serviceUnitName, e);
		}
		// TODO compute return value
		return null;
	}

	public void init(String serviceUnitName, String serviceUnitRootPath)
			throws DeploymentException {
		// no specific init
	}

	public void shutDown(String serviceUnitName) throws DeploymentException {
		// TODO Auto-generated method stub

	}

	public void start(String serviceUnitName) throws DeploymentException {
		// TODO Auto-generated method stub

	}

	public void stop(String serviceUnitName) throws DeploymentException {
		// TODO Auto-generated method stub

	}

	public String undeploy(String serviceUnitName, String serviceUnitRootPath)
			throws DeploymentException {
		clock.removeTimeZonesForArtifact(serviceUnitName);
		return null;
	}

}
