package org.objectweb.petals.engine.clock;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.HashMap;

public class TimeZonesMap {
	private HashMap<String,Integer> data;
	
	public TimeZonesMap(InputStream in) throws IOException{
		BufferedReader reader = new BufferedReader(new InputStreamReader(in));
		while(reader.ready()){
			String line=reader.readLine();
			int separatorIdx=line.indexOf(':');
			String city=line.substring(0,separatorIdx-1);
			Integer timeZone=Integer.parseInt(line.substring(separatorIdx+1));
			data.put(city,timeZone);
		}
	}

	public HashMap<String, Integer> getData() {
		return data;
	}
	
	public void addTimeZone(String city, Integer timeZone) {
		data.put(city,timeZone);
	}
	
	public Integer getTimeZone(String city){
		return data.get(city);
	}
	
}
