package org.objectweb.petals.engine.sampleclient;


import java.util.logging.Level;
import java.util.logging.Logger;

import javax.jbi.messaging.DeliveryChannel;
import javax.jbi.messaging.MessageExchange;
import javax.jbi.messaging.MessagingException;


import org.objectweb.petals.engine.util.SourceHelper;
import org.objectweb.petals.engine.sampleclient.gui.Console;

public class SampleClientListener implements Runnable {

	private DeliveryChannel channel;
	
	private MessageExchange messageExchange;
	
	private boolean running=true;
	
	private Console console;
	
	private Logger logger;
	
	
	public SampleClientListener(DeliveryChannel channel, Console c, Logger log) {
		super();
		this.channel = channel;
		console = c;
		logger = log;
	}

	public void run() {
		
		mainLoop: while(running){
			try 
			{
				messageExchange = channel.accept();
				
				process(messageExchange);

			}
			catch (MessagingException e) {
				logger.severe(this+" run()"+e.getMessage());
				continue mainLoop;
			}
		}

	}

	public  void process(MessageExchange msg) 
	{
		logger.log(Level.INFO,"process("+msg+")");
		
		String response=null;
		
		try
        {
            response = SourceHelper.createString(msg.getMessage("OUT").getContent());
        }
        catch (Exception e) 
        {
    		logger.log(Level.SEVERE,e.getMessage());
    		response = e.getMessage();
        } 
        console.setResponse(response);
	}

	public void stopProcessing(){
		this.running = false;
	}
	
}
