/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): Adrien LOUIS
 * --------------------------------------------------------------------------
 * $Id: InstallationContextImpl.java,v 1.3 2005/07/22 10:24:27 alouis Exp $
 * --------------------------------------------------------------------------  
 */
package org.objectweb.petals.jbi.component;

import java.util.List;

import javax.jbi.component.ComponentContext;
import javax.jbi.component.InstallationContext;

import org.objectweb.petals.jbi.descriptor.ComponentDescription;
import org.w3c.dom.DocumentFragment;

public class InstallationContextImpl implements InstallationContext {

	private ComponentContext context;
	private String componentClassName;
	private String componentName;
	private DocumentFragment installationDescriptorExtension;
 	private String installRoot;
	private boolean install;
	private List classPathElements;


	public InstallationContextImpl(	ComponentDescription component, 
									ComponentContext context,
									boolean install) 
	{
		super();
		
		this.context = new ComponentContextForInstallation(context);
		this.componentClassName = component.getComponentClassName();
		this.componentName = component.getIdentification().getName();
		this.install = install;
		this.classPathElements = component.getComponentClassPath();
		this.installRoot = context.getInstallRoot();
	}

	public List getClassPathElements() {
		return classPathElements;
	}

	public String getComponentClassName() {
		return componentClassName;
	}

	public String getComponentName() {
		return componentName;
	}

	/**
	 * Return a <code>ComponentContextForInstallation</code> wrapper
	 * of the Componentcontext 
	 */
	public ComponentContext getContext() {
		return context;
	}

	public DocumentFragment getInstallationDescriptorExtension() 
	{
		return installationDescriptorExtension;
	}

	public String getInstallRoot() {
		return installRoot;
	}

	public boolean isInstall() {
		return install;
	}

	/**
	 * TODO must redefine the classpath at the execution time
	 */
	public void setClassPathElements(List classPathElements) {
		this.classPathElements = classPathElements;
	}

}
