package org.objectweb.petals.jbi.descriptor;

/**
 * The identification production is used to provide identifying information
 * for components, shared libraries, service units, and service assemblies.
 *
 * @version	$Rev: 76 $ $Date: 2006-01-17 18:15:44 +0100 (mar., 17 janv. 2006) $
 * @since	Petals 1.0
 * @author	<a href="mailto:rmarins@fossilec.com">Rafael Marins</a>
 */
public class Identification {

	/**
	 * Item name.
	 */
	private String name;

	/**
	 * Item description.
	 */
	private String description;

	/**
	 * Default constructor.
	 */
	Identification() {
		super();
	}

	//
	// Getters and Setters
	//

	/**
	 * The name of the item. This is a human-friendly identifier for the
	 * item.
	 *
	 * @return <code>String</code> the item name.
	 */
	public String getName() {
		return name;
	}

	/**
	 * The name of the item. This is a human-friendly identifier for the
	 * item.
	 *
	 * @param name <code>String</code> item name to set.
	 */
	void setName(String name) {
		this.name = name;
	}

	/**
	 * A longer (one sentence) description of the item.
	 *
	 * @return <code>String</code> the item description.
	 */
	public String getDescription() {
		return description;
	}

	/**
	 * A longer (one sentence) description of the item.
	 *
	 * @param description <code>String</code> item description to set.
	 */
	void setDescription(String description) {
		this.description = description;
	}

}