package org.objectweb.petals.jbi.descriptor;

import java.util.List;

/**
 * Shared library list production is used together with a parametrized
 * {@link List} to provide the pair info of shared library listing used by
 * the component.
 *
 * @version	$Rev: 76 $ $Date: 2006-01-17 18:15:44 +0100 (mar., 17 janv. 2006) $
 * @since	Petals 1.0
 * @author	<a href="mailto:rmarins@fossilec.com">Rafael Marins</a>
 */
public class SharedLibraryList {

	/**
	 * Shared library name.
	 */
	private String name;

	/**
	 * Optional shared library version.
	 */
	private String version;

	/**
	 * Default constructor.
	 */
	SharedLibraryList() {
		super();
	}

	//
	// Getters and Setters
	//

	/**
	 * Returns the shared library name. 
	 *
	 * @return <code>String</code> the shared library name.
	 */
	public String getName() {
		return name;
	}

	/**
	 * Returns the shared library version. May be <code>null</code> since
	 * it's optional.
	 *
	 * @return <code>String</code> optional shared library version. 
	 */
	public String getVersion() {
		return version;
	}

	/**
	 * Set shared library name.
	 *
	 * @param name <code>String</code> shared library name.
	 */
	void setName(String name) {
		this.name = name;
	}

	/**
	 * Set the optional shared library version.
	 *
	 * @param version <code>String</code> shared library version.
	 */
	void setVersion(String version) {
		this.version = version;
	}

}