/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 Fossil E-Commerce, http://www.fossilec.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: EndpointGroup.java 76 2006-01-17 17:15:44Z rmarins $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.jbi.registry;

import javax.jbi.servicedesc.ServiceEndpoint;
import javax.xml.namespace.QName;

/**
 * @version	$Rev: 76 $ $Date: 2006-01-17 18:15:44 +0100 (mar., 17 janv. 2006) $
 * @since	Petals 1.0
 * @author	<a href="mailto:rmarins@fossilec.com">Rafael Marins</a>
 */
public interface EndpointGroup {

	/**
	 * 
	 * @param endpoint
	 */
	void add(AbstractEndpoint endpoint);

	/**
	 * @param serviceName
	 * @param endpointName
	 * @return
	 */
	boolean contains(QName serviceName, String endpointName);

	/**
	 * @param serviceName
	 * @param endpointName
	 * @return
	 */
	AbstractEndpoint getEndpoint(QName serviceName, String endpointName);

	/**
	 * @param serviceName
	 * @return
	 */
	AbstractEndpoint[] getEndpointsForService(QName serviceName);

	/**
	 * @param interfaceName
	 * @return
	 */
	AbstractEndpoint[] getEndpointsForInterface(QName interfaceName);

	/**
	 * @param endpoint
	 */
	void remove(ServiceEndpoint endpoint);
}
