/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 Fossil E-Commerce, http://www.fossilec.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: InternalEndpoint.java 216 2006-04-13 14:18:14Z ofabre $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.jbi.registry;

import javax.xml.namespace.QName;

import org.objectweb.petals.jbi.component.ComponentContextImpl;

/**
 * @version	$Rev: 216 $ $Date: 2006-04-13 16:18:14 +0200 (jeu., 13 avr. 2006) $
 * @since	Petals 1.0
 * @author	<a href="mailto:rmarins@fossilec.com">Rafael Marins</a>
 */
public class InternalEndpoint extends AbstractEndpoint {

	/**
	 * References the context of the component that provides this endpoint 
	 */ 
	ComponentContextImpl ctx;
	
	/**
	 * @param endpointName 
	 * @param serviceName 
	 * 
	 */
	public InternalEndpoint(QName serviceName, String endpointName, ComponentContextImpl ctx) {
		super(serviceName, endpointName);
		this.ctx=ctx;
	}

	public ComponentContextImpl getComponentContext() {
		return ctx;
	}

}
