/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 Fossil E-Commerce, http://www.fossilec.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: RegistryManager.java 216 2006-04-13 14:18:14Z ofabre $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.jbi.registry;

import javax.jbi.JBIException;
import javax.jbi.servicedesc.ServiceEndpoint;
import javax.xml.namespace.QName;

import org.objectweb.petals.jbi.component.ComponentContextImpl;


/**
 * @version	$Rev: 216 $ $Date: 2006-04-13 16:18:14 +0200 (jeu., 13 avr. 2006) $
 * @since	Petals 1.0
 * @author	<a href="mailto:rmarins@fossilec.com">Rafael Marins</a>
 */
public interface RegistryManager {

	/**
	 * @see javax.jbi.component.ComponentContext#deactivateEndpoint(javax.jbi.servicedesc.ServiceEndpoint)
	 */
    void deregisterInternalEndpoint(
    		ServiceEndpoint endpoint)
    		throws JBIException;

	/**
	 * @see javax.jbi.component.ComponentContext#deregisterExternalEndpoint(javax.jbi.servicedesc.ServiceEndpoint)
	 */
    void deregisterExternalEndpoint(
    		ServiceEndpoint externalEndpoint)
    		throws JBIException;

    /**
     * @see javax.jbi.component.ComponentContext#getEndpoint(javax.xml.namespace.QName, java.lang.String)
     */
    ServiceEndpoint getInternalEndpoint(QName service, String name);
    
	/**
	 * @see javax.jbi.component.ComponentContext#getEndpoints(javax.xml.namespace.QName)
	 */
    ServiceEndpoint[] getInternalEndpointsForInterface(
    		QName interfaceName);

	/**
	 * @see javax.jbi.component.ComponentContext#getEndpointsForService(javax.xml.namespace.QName)
	 */
    ServiceEndpoint[] getInternalEndpointsForService(
    		QName serviceName);

	/**
	 * @see javax.jbi.component.ComponentContext#getExternalEndpoints(javax.xml.namespace.QName)
	 */
    ServiceEndpoint[] getExternalEndpointsForInterface(
    		QName interfaceName);

	/**
	 * @see javax.jbi.component.ComponentContext#getExternalEndpointsForService(javax.xml.namespace.QName)
	 */
    ServiceEndpoint[] getExternalEndpointsForService(
    		QName serviceName);

	/**
	 * @see javax.jbi.component.ComponentContext#activateEndpoint(javax.xml.namespace.QName, java.lang.String)
	 */
    ServiceEndpoint registerInternalEndpoint(
            javax.xml.namespace.QName serviceName,
            String endpointName, ComponentContextImpl ctx)
            throws javax.jbi.JBIException;

	/**
	 * @see javax.jbi.component.ComponentContext#registerExternalEndpoint(javax.jbi.servicedesc.ServiceEndpoint)
	 */
    void registerExternalEndpoint(
    		ServiceEndpoint externalEndpoint)
    		throws JBIException;

}
