/*
 * PETALS: PETALS Services Platform
 * Copyright (C) 2005  EBM WebSourcing
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA.
 *
 * Initial developer(s): EBM WebSourcing
 * --------------------------------------------------------------------------
 * $Id: Transporter.java,v 0.3 2005/07/22 10:24:27 alouis Exp $
 * --------------------------------------------------------------------------  
 */

package org.objectweb.petals.jbi.transport;

import org.objectweb.petals.jbi.messaging.MessageExchangeImpl;

/**
 * @author alouis
 *
 */
public interface Transporter {

	/**
	 * send the exchange to the consumer, set the Role to 'consumer' 
	 */
	public void sendToConsumer(MessageExchangeImpl exchange) throws TransportException;
	
	/**
	 * send the exchange to the provider, set the Role to 'provider' 
	 */
	public void sendToProvider(MessageExchangeImpl exchange) throws TransportException;
    
}
