/**
 * PETALS - PETALS Services Platform.
 * Copyright (c) 2005 Fossil E-Commerce, http://www.fossilec.com/
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * -------------------------------------------------------------------------
 * $Id: XmlHelper.java 96 2006-02-24 09:35:32Z ofabre $
 * -------------------------------------------------------------------------
 */
package org.objectweb.petals.jbi.util;

import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

/**
 * @version	$Rev: 96 $ $Date: 2006-02-24 10:35:32 +0100 (ven., 24 févr. 2006) $
 * @since	Petals 1.0
 * @author	<a href="mailto:rmarins@fossilec.com">Rafael Marins</a>
 */
public class XmlHelper {

	/**
	 * 
	 */
	private XmlHelper() {
		super();
	}

	public static String getText(Node node) {
	
		if (node == null) {
			return null;
		}
	
		Text text = (Text) node.getFirstChild();
		String value = text.getData().trim();
	
		return value;
	}

	/**
	 * 
	 * @param node
	 * @param attrName
	 * @return
	 */
	public static String getAttribute(Node node, String attrName) {
	
		Node attr = node.getAttributes().getNamedItem(attrName);
	
		return (attr == null ? null : attr.getNodeValue());
	}

	/**
	 * @param list
	 * @return
	 */
	public static List<String> getSimpleArray(NodeList list) {

		if (list == null) {
			return null;
		}

		int size = list.getLength();

		if (size == 0) {
			return null;
		}

		List<String> result = new ArrayList<String>();

		for (int i=0; i<size; i++) {
			Node pathElement = list.item(i);
			result.add( getText(pathElement) );
		}

		return result;
	}


}
