package org.objectweb.petals.jbi.messaging;

import javax.jbi.messaging.InOut;
import javax.jbi.messaging.NormalizedMessage;
import javax.xml.namespace.QName;
import javax.xml.transform.Source;

import junit.framework.TestCase;

import org.objectweb.petals.jbi.component.ComponentContextImpl;

public class DeliveryChannelTest extends TestCase {

	/**
	 */
	public void testGetDeliveryChannel() throws Exception {
		ComponentContextImpl ctx = new ComponentContextImpl();
		MessagingService msgSrv = new MessagingServiceImpl(); 
		DeliveryChannelImpl dc = (DeliveryChannelImpl)msgSrv.loadDeliveryChannel(ctx);
		ctx.setDeliveryChannel(dc);
		
		assertNotNull(dc);
	}	

	/**
	 */
	public void testSendMessage() throws Exception {
		String content = "Tester";
		ComponentContextImpl ctx = new ComponentContextImpl();
		MessagingService msgSrv = new MessagingServiceImpl(); 
		DeliveryChannelImpl dc = (DeliveryChannelImpl)msgSrv.loadDeliveryChannel(ctx);
		ctx.setDeliveryChannel(dc);
		
		Source source = SourceHelper.createContentSource(content);
		
		InOut msg = dc.createExchangeFactory().createInOutExchange();
		
		assertNotNull(msg);
		
		NormalizedMessage nm = msg.createMessage();
		
		nm.setContent(source);
		
		msg.setService(new QName("HelloService"));
		
		msg.setOperation(new QName("hello"));
		
		msg.setInMessage(nm);
		
		dc.send(msg);			
	}
}	