package org.objectweb.petals.jbi.messaging;


import javax.jbi.messaging.MessagingException;

import javax.jbi.messaging.MessageExchange.Role;

import org.objectweb.petals.jbi.messaging.types.InOnlyImpl;
import org.objectweb.petals.jbi.messaging.types.InOutImpl;

import junit.framework.TestCase;

public class MessageExchangeTest extends TestCase {

	/*
	 * Test method for 'org.objectweb.petals.jbi.messaging.MessageExchangeImpl.setError(Exception)'
	 */
	public void testSetError() {

	}

	/*
	 * Test method for 'org.objectweb.petals.jbi.messaging.MessageExchangeImpl.setFault(Fault)'
	 */
	public void testSetFault() {

	}

	/*
	 * Test method for 'org.objectweb.petals.jbi.messaging.MessageExchangeImpl.setMessage(NormalizedMessage, String)'
	 */
	public void testSetMessage() throws Exception
	{
		// test exception on null pattern
		boolean test=false;
		MessageExchangeImpl me = new MessageExchangeImpl(null);
		
		try {
			me.setMessage(null,null);
		} catch (MessagingException e) {
			test=true;
		}
		assertTrue(test);
		
		test=false;
		me.setPattern(MessageExchangeImpl.IN_ONLY_PATTERN);
		
		// test exception on null msg
		try {
			new MessageExchangeImpl(null).setMessage(null,null);
		} catch (MessagingException e) {
			test=true;
		}
		assertTrue(test);
	
		// test exception on null ref
		try {
			new MessageExchangeImpl(null).setMessage(new NormalizedMessageImpl(),null);
		} catch (MessagingException e) {
			test=true;
		}
		assertTrue(test);
	
		//test inonly and consumer
		InOnlyImpl inOnly = new InOnlyImpl(new MessageExchangeImpl(null),Role.CONSUMER);
		inOnly.setInMessage(new NormalizedMessageImpl());
		
		// test inout and provider
		InOutImpl inout = new InOutImpl(new MessageExchangeImpl(null),Role.PROVIDER);
		inout.setOutMessage(new NormalizedMessageImpl());
		
		// test inonly and provider
		InOnlyImpl inOnly2 = new InOnlyImpl(new MessageExchangeImpl(null),Role.PROVIDER);
		inOnly2.setInMessage(new NormalizedMessageImpl());
		test=false;
		try {
			inOnly2.setMessage(new NormalizedMessageImpl(),null);
		} catch (MessagingException e) {
			test=true;
		}
		assertTrue(test);
	}

}
