package org.objectweb.petals.kernel.fractal.mx4j;

import java.io.ObjectInputStream;
import java.util.Set;

import javax.management.Attribute;
import javax.management.AttributeList;
import javax.management.AttributeNotFoundException;
import javax.management.InstanceAlreadyExistsException;
import javax.management.InstanceNotFoundException;
import javax.management.IntrospectionException;
import javax.management.InvalidAttributeValueException;
import javax.management.ListenerNotFoundException;
import javax.management.MBeanException;
import javax.management.MBeanInfo;
import javax.management.MBeanRegistrationException;
import javax.management.MBeanServer;
import javax.management.NotCompliantMBeanException;
import javax.management.NotificationFilter;
import javax.management.NotificationListener;
import javax.management.ObjectInstance;
import javax.management.ObjectName;
import javax.management.OperationsException;
import javax.management.QueryExp;
import javax.management.ReflectionException;
import javax.management.loading.ClassLoaderRepository;

import org.objectweb.fractal.jmx.agent.Agent;

public class MX4J_Agent extends Agent implements MBeanServer {

	public ObjectInstance createMBean(String className, ObjectName name)
			throws ReflectionException, InstanceAlreadyExistsException,
			MBeanRegistrationException, MBeanException,
			NotCompliantMBeanException {
		
		return getRawMBeanServer().createMBean(className, name);
	}

	public ObjectInstance createMBean(String className, ObjectName name,
			ObjectName loaderName) throws ReflectionException,
			InstanceAlreadyExistsException, MBeanRegistrationException,
			MBeanException, NotCompliantMBeanException,
			InstanceNotFoundException {
		
		return getRawMBeanServer().createMBean(className, name, loaderName);
	}

	public ObjectInstance createMBean(String className, ObjectName name,
			Object[] params, String[] signature) throws ReflectionException,
			InstanceAlreadyExistsException, MBeanRegistrationException,
			MBeanException, NotCompliantMBeanException {
		
		return getRawMBeanServer().createMBean(className, name, params, signature);
	}

	public ObjectInstance createMBean(String className, ObjectName name,
			ObjectName loaderName, Object[] params, String[] signature)
			throws ReflectionException, InstanceAlreadyExistsException,
			MBeanRegistrationException, MBeanException,
			NotCompliantMBeanException, InstanceNotFoundException {
		return getRawMBeanServer().createMBean(className, name, loaderName, params, signature);
	}

	public ObjectInstance registerMBean(Object object, ObjectName name)
			throws InstanceAlreadyExistsException, MBeanRegistrationException,
			NotCompliantMBeanException {
		return getRawMBeanServer().registerMBean(object, name);
	}

	public void unregisterMBean(ObjectName name)
			throws InstanceNotFoundException, MBeanRegistrationException {
		getRawMBeanServer().unregisterMBean(name);

	}

	public ObjectInstance getObjectInstance(ObjectName name)
			throws InstanceNotFoundException {
		return getRawMBeanServer().getObjectInstance(name);
	}

	public Set queryMBeans(ObjectName name, QueryExp query) {
		return getRawMBeanServer().queryMBeans(name, query);
	}

	public Set queryNames(ObjectName name, QueryExp query) {
		return getRawMBeanServer().queryNames(name, query);
	}

	public boolean isRegistered(ObjectName name) {
		return getRawMBeanServer().isRegistered(name);
	}

	public Integer getMBeanCount() {
		return getRawMBeanServer().getMBeanCount();
	}

	public Object getAttribute(ObjectName name, String attribute)
			throws MBeanException, AttributeNotFoundException,
			InstanceNotFoundException, ReflectionException {
		return getRawMBeanServer().getAttribute(name, attribute);
	}

	public AttributeList getAttributes(ObjectName name, String[] attributes)
			throws InstanceNotFoundException, ReflectionException {
		return getRawMBeanServer().getAttributes(name, attributes);
	}

	public void setAttribute(ObjectName name, Attribute attribute)
			throws InstanceNotFoundException, AttributeNotFoundException,
			InvalidAttributeValueException, MBeanException, ReflectionException {
		getRawMBeanServer().setAttribute(name, attribute);

	}

	public AttributeList setAttributes(ObjectName name, AttributeList attributes)
			throws InstanceNotFoundException, ReflectionException {

		return getRawMBeanServer().setAttributes(name, attributes);
	}

	public Object invoke(ObjectName name, String operationName,
			Object[] params, String[] signature)
			throws InstanceNotFoundException, MBeanException,
			ReflectionException {
		return getRawMBeanServer().invoke(name, operationName, params, signature);
	}

	public String getDefaultDomain() {
		return getRawMBeanServer().getDefaultDomain();
	}

	public String[] getDomains() {
		return getRawMBeanServer().getDomains();
	}

	public void addNotificationListener(ObjectName name,
			NotificationListener listener, NotificationFilter filter,
			Object handback) throws InstanceNotFoundException {
		getRawMBeanServer().addNotificationListener(name, listener, filter, handback);

	}

	public void addNotificationListener(ObjectName name, ObjectName listener,
			NotificationFilter filter, Object handback)
			throws InstanceNotFoundException {
		getRawMBeanServer().addNotificationListener(name, listener, filter, handback);

	}

	public void removeNotificationListener(ObjectName name, ObjectName listener)
			throws InstanceNotFoundException, ListenerNotFoundException {
		getRawMBeanServer().removeNotificationListener(name, listener);

	}

	public void removeNotificationListener(ObjectName name,
			ObjectName listener, NotificationFilter filter, Object handback)
			throws InstanceNotFoundException, ListenerNotFoundException {
		getRawMBeanServer().removeNotificationListener(name, listener, filter, handback);

	}

	public void removeNotificationListener(ObjectName name,
			NotificationListener listener) throws InstanceNotFoundException,
			ListenerNotFoundException {
		getRawMBeanServer().removeNotificationListener(name, listener);


	}

	public void removeNotificationListener(ObjectName name,
			NotificationListener listener, NotificationFilter filter,
			Object handback) throws InstanceNotFoundException,
			ListenerNotFoundException {
		getRawMBeanServer().removeNotificationListener(name, listener, filter, handback);

	}

	public MBeanInfo getMBeanInfo(ObjectName name)
			throws InstanceNotFoundException, IntrospectionException,
			ReflectionException {
		return getRawMBeanServer().getMBeanInfo(name);
	}

	public boolean isInstanceOf(ObjectName name, String className)
			throws InstanceNotFoundException {
		return getRawMBeanServer().isInstanceOf(name, className);
	}

	public Object instantiate(String className) throws ReflectionException,
			MBeanException {
		return getRawMBeanServer().instantiate(className);
	}

	public Object instantiate(String className, ObjectName loaderName)
			throws ReflectionException, MBeanException,
			InstanceNotFoundException {
		return getRawMBeanServer().instantiate(className, loaderName);
	}

	public Object instantiate(String className, Object[] params,
			String[] signature) throws ReflectionException, MBeanException {
		return getRawMBeanServer().instantiate(className, params, signature);
	}

	public Object instantiate(String className, ObjectName loaderName,
			Object[] params, String[] signature) throws ReflectionException,
			MBeanException, InstanceNotFoundException {
		return getRawMBeanServer().instantiate(className, loaderName, params, signature);
	}

	@SuppressWarnings("deprecation")
	public ObjectInputStream deserialize(ObjectName name, byte[] data)
			throws InstanceNotFoundException, OperationsException {
		return getRawMBeanServer().deserialize(name, data);
	}

	@SuppressWarnings("deprecation")
	public ObjectInputStream deserialize(String className, byte[] data)
			throws OperationsException, ReflectionException {
		return getRawMBeanServer().deserialize(className, data);
	}

	@SuppressWarnings("deprecation")
	public ObjectInputStream deserialize(String className,
			ObjectName loaderName, byte[] data)
			throws InstanceNotFoundException, OperationsException,
			ReflectionException {
		return getRawMBeanServer().deserialize(className, loaderName, data);
	}

	public ClassLoader getClassLoaderFor(ObjectName mbeanName)
			throws InstanceNotFoundException {
		return getRawMBeanServer().getClassLoaderFor(mbeanName);
	}

	public ClassLoader getClassLoader(ObjectName loaderName)
			throws InstanceNotFoundException {
		return getRawMBeanServer().getClassLoader(loaderName);
	}

	public ClassLoaderRepository getClassLoaderRepository() {
		return getRawMBeanServer().getClassLoaderRepository();
	}

}
